from time import strftime
from selenium import webdriver
import allure
from selenium.webdriver.support.wait import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC

class Exec:
    def __init__(self,data):
        self.data = data
        if 'browser' in self.data[0]:
            if self.data[0]['browser'] == 'chrome':
                self.driver = webdriver.Chrome()
            elif self.data[0]['browser'] == 'firefox':
                self.driver = webdriver.Firefox()
        self.driver.implicitly_wait(10)

    def get_element(self,locator,timeout=5,poll_frequency=0.5,desc=None):
        try:
            return WebDriverWait(self.driver, timeout, poll_frequency). \
                until(EC.visibility_of_element_located(locator))
        except:
            curtime = strftime('%Y%m%d%H%M%S')  # 年月日时分秒
            self.driver.save_screenshot(f'./screenshots/{curtime}{desc}.png')


    def goto(self):
        for one in self.data:
            if one.get('goto'):
                goto_data = one.pop('goto')
                step,step_text = list(one.items())[0]
                with allure.step(f'步骤{step}:{step_text}'):
                    self.driver.get(goto_data)
                    break
        return self

    def input(self):
        for one in self.data:
            if one.get('input'):
                input_ele = one.pop('input')
                step,step_text = list(one.items())[0]
                with allure.step(f'步骤{step}:{step_text}'):
                    self.driver.find_element(*input_ele[:-1],desc=step_text).send_keys(input_ele[-1])
                    break
        return self

    def click(self):
        for one in self.data:
            if one.get('click'):
                click_data = one.pop('click')
                step, step_text = list(one.items())[0]
                with allure.step(f'步骤{step}:{step_text}'):
                    self.driver.find_element(*click_data,desc=step_text).click()
                    break
        return self


    def def_assert(self,save_data):
        var = save_data[0]
        result = save_data[1]
        for one in self.data:
            if one.get('assert'):
                assert_data = one.pop('assert')
                step, step_text = list(one.items())[0]
                with allure.step(f'步骤{step}:{step_text}'):
                    if var in assert_data[-1]:
                        assert_msg = assert_data
                        try:
                            if var in assert_msg:
                                assert var == result
                            else:
                                assert assert_msg[0] == result
                        except Exception as error:
                            self.driver.save_screenshot(f'{step_text}断言失败.png')


    def save_text(self):
        for one in self.data:
            if one.get('save_text'):
                text_ele = one.pop('save_text')
                step, step_text = list(one.items())[0]
                with allure.step(f'步骤{step}:{step_text}'):
                    text_msg = self.driver.find_element(*text_ele[:-1]).text
                    var = text_msg[-1]
        return var,text_msg


